Scriptname fm4sAddBathtubSpellScript extends activemagiceffect  

Actor Property PlayerRef auto
ObjectReference Property fm4sBathtubMarker auto
fm4s Property fm4sQuest auto
bool active
Cell bathtubCell

Event OnEffectStart(Actor caster, Actor target)
	fm4sBathtubMarker.enable()
	float pZ = PlayerRef.getAngleZ()
	fm4sBathtubMarker.setAngle(0, 0, pZ - 90.0)
	fm4sBathtubMarker.moveTo(PlayerRef, 10.0 * Math.Sin(pZ), 10.0 * Math.Cos(pZ), PlayerRef.getHeight() - 128, false)
	active=true
	RegisterForSingleUpdate(0.05)
EndEvent

Event OnEffectFinish(Actor caster, Actor target)
	active=false
	Utility.wait(0.1)
	if StringUtil.find(self as string, "00000014")!=-1
		UnregisterForUpdate()
	endIf
	fm4sBathtubMarker.disable()
	fm4sQuest.addBathtub()
EndEvent

Event OnUpdate()
	if !active
		return
	endIf
	float pZ = PlayerRef.getAngleZ()
	cell playerCell = PlayerRef.getParentCell()
	if playerCell != bathtubCell
		fm4sBathtubMarker.moveTo(PlayerRef)
		bathtubCell = fm4sBathtubMarker.getParentCell()
		Utility.wait(0.1)
	endIf
	if fm4sBathtubMarker && bathtubCell && fm4sBathtubMarker.is3DLoaded() && !fm4sBathtubMarker.isDisabled()
		fm4sBathtubMarker.translateTo(PlayerRef.X + fm4sQuest.markerDistance * math.sin(pZ+1.0), PlayerRef.Y + fm4sQuest.markerDistance * math.cos(pZ+1.0), PlayerRef.Z, 0.0, 0.0, pZ - 90.0, 250.0)
	endIf
	Utility.wait(0.1)
	if active && StringUtil.find(self as string, "00000014")!=-1
		RegisterForSingleUpdate(0.2)
	endIf
EndEvent

