Scriptname fm4sAddShowerSpellScript extends activemagiceffect  

Actor Property PlayerRef auto
ObjectReference Property fm4sShowerMarker auto
fm4s Property fm4sQuest auto
bool active
Cell showerCell

Event OnEffectStart(Actor caster, Actor target)
	fm4sShowerMarker.enable()
	float pZ = PlayerRef.getAngleZ()
	fm4sShowerMarker.setAngle(0, 0, pZ + 180.0)
	fm4sShowerMarker.moveTo(PlayerRef, 10.0 * Math.Sin(pZ), 10.0 * Math.Cos(pZ), PlayerRef.getHeight() - 128, false)
	active=true
	RegisterForSingleUpdate(0.05)
EndEvent

Event OnEffectFinish(Actor caster, Actor target)
	active=false
	Utility.wait(0.1)
	if StringUtil.find(self as string, "00000014")!=-1
		UnregisterForUpdate()
	endIf
	fm4sShowerMarker.disable()
	fm4sQuest.addShower()
EndEvent

Event OnUpdate()
	if !active
		return
	endIf
	float pZ = PlayerRef.getAngleZ()
	cell playerCell = PlayerRef.getParentCell()
	if playerCell != showerCell
		fm4sShowerMarker.moveTo(PlayerRef)
		showerCell = fm4sShowerMarker.getParentCell()
		Utility.wait(0.1)
	endIf
	if fm4sShowerMarker && showerCell && fm4sShowerMarker.is3DLoaded() && !fm4sShowerMarker.isDisabled()
		fm4sShowerMarker.translateTo(PlayerRef.X + fm4sQuest.markerDistance * math.sin(pZ+1.0), PlayerRef.Y + fm4sQuest.markerDistance * math.cos(pZ+1.0), PlayerRef.Z, 0.0, 0.0, pZ + 180.0, 250.0)
	endIf
	Utility.wait(0.1)
	if active && StringUtil.find(self as string, "00000014")!=-1
		RegisterForSingleUpdate(0.2)
	endIf
EndEvent

