Scriptname fm4sAddToiletSpellScript extends activemagiceffect  

Actor Property PlayerRef auto
ObjectReference Property fm4sToiletMarker auto
fm4s Property fm4sQuest auto
bool active
Cell toiletCell

Event OnEffectStart(Actor caster, Actor target)
	fm4sToiletMarker.enable()
	float pZ = PlayerRef.getAngleZ()
	fm4sToiletMarker.setAngle(0, 0, pZ)
	fm4sToiletMarker.moveTo(PlayerRef, 10.0 * Math.Sin(pZ), 10.0 * Math.Cos(pZ), PlayerRef.getHeight() - 128, false)
	active=true
	RegisterForSingleUpdate(0.05)
EndEvent

Event OnEffectFinish(Actor caster, Actor target)
	active=false
	Utility.wait(0.1)
	if StringUtil.find(self as string, "00000014")!=-1
		UnregisterForUpdate()
	endIf
	fm4sToiletMarker.disable()
	fm4sQuest.addToilet()
EndEvent

Event OnUpdate()
	if !active
		return
	endIf
	float pZ = PlayerRef.getAngleZ()
	cell playerCell = PlayerRef.getParentCell()
	if playerCell != toiletCell
		fm4sToiletMarker.moveTo(PlayerRef)
		toiletCell = fm4sToiletMarker.getParentCell()
		Utility.wait(0.1)
	endIf
	if fm4sToiletMarker && toiletCell && fm4sToiletMarker.is3DLoaded() && !fm4sToiletMarker.isDisabled()
		fm4sToiletMarker.translateTo(PlayerRef.X + fm4sQuest.markerDistance * math.sin(pZ+1.0), PlayerRef.Y + fm4sQuest.markerDistance * math.cos(pZ+1.0), PlayerRef.Z - 0.1, 0.0, 0.0, pZ, 250.0)
	endIf
	Utility.wait(0.1)
	if active && StringUtil.find(self as string, "00000014")!=-1
		RegisterForSingleUpdate(0.2)
	endIf
EndEvent

